'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _get = function get(_x3, _x4, _x5) { var _again = true; _function: while (_again) { var object = _x3, property = _x4, receiver = _x5; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x3 = parent; _x4 = property; _x5 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

exports.createModuleDeclaration = createModuleDeclaration;
exports.createExportAllFrom = createExportAllFrom;
exports.createExportDeclaration = createExportDeclaration;
exports.createVariableDeclaration = createVariableDeclaration;
exports.createVariableDeclarator = createVariableDeclarator;
exports.createExportSpecifier = createExportSpecifier;
exports.createExport = createExport;
exports.createParam = createParam;
exports.createFunction = createFunction;
exports.createInterface = createInterface;
exports.createInterfaceMethod = createInterfaceMethod;
exports.createInterfaceProperty = createInterfaceProperty;
exports.createInterfaceIndexer = createInterfaceIndexer;
exports.createInterfaceCall = createInterfaceCall;
exports.createClass = createClass;
exports.createClassConstructor = createClassConstructor;
exports.createClassMethod = createClassMethod;
exports.createClassProperty = createClassProperty;

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _utils = require('./utils');

var Node = (function () {
  function Node() {
    _classCallCheck(this, Node);

    this._leadingComments = null;
  }

  _createClass(Node, [{
    key: 'fromSource',
    value: function fromSource(node) {
      this._leadingComments = node.leadingComments || null;

      return this;
    }
  }, {
    key: 'toCode',
    value: function toCode(ctx) {
      var output = this._getCommentString(ctx) + this._toCode(ctx);

      return output.split('\n').map(indent(ctx)).join('\n');
    }
  }, {
    key: 'toString',
    value: function toString() {
      var ctx = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      return this.toCode(_extends({}, emptyCtx(), ctx));
    }
  }, {
    key: '_getCommentString',
    value: function _getCommentString(_ref) {
      var suppressComments = _ref.suppressComments;

      if (suppressComments) {
        return '';
      }

      var comments = this._leadingComments ? this._leadingComments.map(function (s) {
        switch (s.type) {
          case 'CommentLine':
            return '// ' + s.value;

          case 'CommentBlock':
            return '/*' + s.value + '*/';

          default:
            return null;
        }
      }).filter(_utils.id).join('\n') : '';

      return comments.length === 0 ? '' : '\n' + comments + '\n';
    }

    // Note: _toCode is not expected to indent itself, only children.
  }, {
    key: '_toCode',
    value: function _toCode() {
      throw new Error('toCode is abstract.');
    }
  }, {
    key: '_includeComments',
    value: function _includeComments() {
      return true;
    }
  }]);

  return Node;
})();

var ModuleDeclarationNode = (function (_Node) {
  _inherits(ModuleDeclarationNode, _Node);

  function ModuleDeclarationNode(name, children) {
    _classCallCheck(this, _ModuleDeclarationNode);

    _get(Object.getPrototypeOf(_ModuleDeclarationNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._children = children;
  }

  _createClass(ModuleDeclarationNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var code = this._children.map(toCode(ctx.indent())).join('\n');
      return 'declare module ' + this._name + ' {\n' + code + '\n}';
    }
  }]);

  var _ModuleDeclarationNode = ModuleDeclarationNode;
  ModuleDeclarationNode = (0, _utils.factory)(ModuleDeclarationNode) || ModuleDeclarationNode;
  return ModuleDeclarationNode;
})(Node);

var ExportAllFromNode = (function (_Node2) {
  _inherits(ExportAllFromNode, _Node2);

  function ExportAllFromNode(source) {
    _classCallCheck(this, _ExportAllFromNode);

    _get(Object.getPrototypeOf(_ExportAllFromNode.prototype), 'constructor', this).call(this);

    this._source = source;
  }

  _createClass(ExportAllFromNode, [{
    key: '_toCode',
    value: function _toCode() {
      return 'export * from \'' + this._source + '\';';
    }
  }]);

  var _ExportAllFromNode = ExportAllFromNode;
  ExportAllFromNode = (0, _utils.factory)(ExportAllFromNode) || ExportAllFromNode;
  return ExportAllFromNode;
})(Node);

var ExportNamedDeclarationNode = (function (_Node3) {
  _inherits(ExportNamedDeclarationNode, _Node3);

  function ExportNamedDeclarationNode(declaration) {
    _classCallCheck(this, _ExportNamedDeclarationNode);

    _get(Object.getPrototypeOf(_ExportNamedDeclarationNode.prototype), 'constructor', this).call(this);

    this._declaration = declaration;
  }

  _createClass(ExportNamedDeclarationNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var decl = this._declaration.toCode(_extends({}, ctx, { level: 0 }));
      var suffix = this._declaration.preventSemi ? '' : ';';

      return 'export ' + decl + suffix;
    }
  }]);

  var _ExportNamedDeclarationNode = ExportNamedDeclarationNode;
  ExportNamedDeclarationNode = (0, _utils.factory)(ExportNamedDeclarationNode) || ExportNamedDeclarationNode;
  return ExportNamedDeclarationNode;
})(Node);

var VariableDeclarationNode = (function (_Node4) {
  _inherits(VariableDeclarationNode, _Node4);

  function VariableDeclarationNode(kind, declarations) {
    _classCallCheck(this, _VariableDeclarationNode);

    _get(Object.getPrototypeOf(_VariableDeclarationNode.prototype), 'constructor', this).call(this);

    this._kind = kind;
    this._declarations = declarations;
  }

  _createClass(VariableDeclarationNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var kind = this._kind;
      var declarations = this._declarations.map(toCode(_extends({}, ctx, { level: 0 }))).filter(_utils.id);
      if (declarations.length === 0) {
        return null;
      }

      if (declarations.length > 1) {
        (function () {
          var extraIndent = ctx.multiVarStep;

          var doIndent = indent({ level: 1, step: extraIndent });
          declarations = declarations.map(function (dec, i) {
            if (i === 0) {
              return dec;
            }

            return doIndent(dec);
          });
        })();
      }

      var decCode = declarations.join(',\n');

      return kind + ' ' + decCode;
    }
  }]);

  var _VariableDeclarationNode = VariableDeclarationNode;
  VariableDeclarationNode = (0, _utils.factory)(VariableDeclarationNode) || VariableDeclarationNode;
  return VariableDeclarationNode;
})(Node);

var VariableDeclaratorNode = (function (_Node5) {
  _inherits(VariableDeclaratorNode, _Node5);

  function VariableDeclaratorNode(name, type) {
    _classCallCheck(this, _VariableDeclaratorNode);

    _get(Object.getPrototypeOf(_VariableDeclaratorNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._type = type;
  }

  _createClass(VariableDeclaratorNode, [{
    key: '_toCode',
    value: function _toCode() {
      return this._name + ': ' + this._type;
    }
  }]);

  var _VariableDeclaratorNode = VariableDeclaratorNode;
  VariableDeclaratorNode = (0, _utils.factory)(VariableDeclaratorNode) || VariableDeclaratorNode;
  return VariableDeclaratorNode;
})(Node);

var ExportSpecifierNode = (function (_Node6) {
  _inherits(ExportSpecifierNode, _Node6);

  function ExportSpecifierNode(exported, local) {
    _classCallCheck(this, _ExportSpecifierNode);

    _get(Object.getPrototypeOf(_ExportSpecifierNode.prototype), 'constructor', this).call(this);

    this._exported = exported;
    this._local = local;
  }

  _createClass(ExportSpecifierNode, [{
    key: '_toCode',
    value: function _toCode() {
      if (!this._local || this._local === this._exported) {
        return '' + this._exported;
      }

      return this._exported + ' as ' + this._local;
    }
  }]);

  var _ExportSpecifierNode = ExportSpecifierNode;
  ExportSpecifierNode = (0, _utils.factory)(ExportSpecifierNode) || ExportSpecifierNode;
  return ExportSpecifierNode;
})(Node);

var ExportNode = (function (_Node7) {
  _inherits(ExportNode, _Node7);

  function ExportNode(exported, source) {
    _classCallCheck(this, _ExportNode);

    _get(Object.getPrototypeOf(_ExportNode.prototype), 'constructor', this).call(this);

    this._exported = exported;
    this._source = source;
  }

  _createClass(ExportNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var exported = this._exported.map(toCode(_extends({}, ctx, { level: 1 }))).join(',\n');

      if (this._source) {
        return 'export {\n' + exported + '\n} from \'' + this._source + '\';';
      }

      return 'export {\n' + exported + '\n};';
    }
  }]);

  var _ExportNode = ExportNode;
  ExportNode = (0, _utils.factory)(ExportNode) || ExportNode;
  return ExportNode;
})(Node);

var ParameterNode = (function (_Node8) {
  _inherits(ParameterNode, _Node8);

  function ParameterNode(name, type, isRest) {
    _classCallCheck(this, _ParameterNode);

    _get(Object.getPrototypeOf(_ParameterNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._type = type;
    this._isRest = isRest;
  }

  _createClass(ParameterNode, [{
    key: 'asRestParam',
    value: function asRestParam() {
      if (this._isRest) {
        return this;
      }

      return ParameterNode(this._name, this._type, true);
    }
  }, {
    key: '_includeComments',
    value: function _includeComments() {
      return false;
    }
  }, {
    key: '_toCode',
    value: function _toCode() {
      return '' + (this._isRest ? '...' : '') + this._name + ': ' + this._type;
    }
  }]);

  var _ParameterNode = ParameterNode;
  ParameterNode = (0, _utils.factory)(ParameterNode) || ParameterNode;
  return ParameterNode;
})(Node);

var MethodNode = (function (_Node9) {
  _inherits(MethodNode, _Node9);

  function MethodNode(name, params, type) {
    _classCallCheck(this, _MethodNode);

    _get(Object.getPrototypeOf(_MethodNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._params = params;
    this._type = type;
  }

  _createClass(MethodNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var params = this._params.map(toCode(_extends({}, ctx, { level: 0 }))).join(', ');
      var type = this._type !== null ? ': ' + this._type : '';

      return (this.name || '') + '(' + params + ')' + type;
    }
  }, {
    key: 'name',
    get: function get() {
      return this._name;
    }
  }]);

  var _MethodNode = MethodNode;
  MethodNode = (0, _utils.factory)(MethodNode) || MethodNode;
  return MethodNode;
})(Node);

var FunctionNode = (function (_MethodNode2) {
  _inherits(FunctionNode, _MethodNode2);

  function FunctionNode(name, params, type) {
    _classCallCheck(this, _FunctionNode);

    _get(Object.getPrototypeOf(_FunctionNode.prototype), 'constructor', this).call(this, name, params, type);
  }

  _createClass(FunctionNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      return 'function ' + _get(Object.getPrototypeOf(_FunctionNode.prototype), '_toCode', this).call(this, ctx);
    }
  }]);

  var _FunctionNode = FunctionNode;
  FunctionNode = (0, _utils.factory)(FunctionNode) || FunctionNode;
  return FunctionNode;
})(MethodNode);

var InterfaceNode = (function (_Node10) {
  _inherits(InterfaceNode, _Node10);

  function InterfaceNode(name, members, baseInterfaces) {
    _classCallCheck(this, _InterfaceNode);

    _get(Object.getPrototypeOf(_InterfaceNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._members = members;
    this._baseInterfaces = baseInterfaces;
  }

  _createClass(InterfaceNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var members = this._members.map(toCode(_extends({}, ctx, { level: 1 }))).join('\n');
      var baseInterfaces = this._baseInterfaces.map(toCode(_extends({}, ctx, { level: 0 }))).join(', ');
      var extendsStr = baseInterfaces.length === 0 ? '' : ' extends ' + baseInterfaces;

      return 'export interface ' + this._name + extendsStr + ' {\n' + members + '\n}';
    }
  }]);

  var _InterfaceNode = InterfaceNode;
  InterfaceNode = (0, _utils.factory)(InterfaceNode) || InterfaceNode;
  return InterfaceNode;
})(Node);

var InterfaceCallNode = (function (_MethodNode3) {
  _inherits(InterfaceCallNode, _MethodNode3);

  function InterfaceCallNode(params, type) {
    _classCallCheck(this, _InterfaceCallNode);

    _get(Object.getPrototypeOf(_InterfaceCallNode.prototype), 'constructor', this).call(this, null, params, type);
  }

  _createClass(InterfaceCallNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      return _get(Object.getPrototypeOf(_InterfaceCallNode.prototype), '_toCode', this).call(this, ctx) + ';';
    }
  }]);

  var _InterfaceCallNode = InterfaceCallNode;
  InterfaceCallNode = (0, _utils.factory)(InterfaceCallNode) || InterfaceCallNode;
  return InterfaceCallNode;
})(MethodNode);

var InterfaceMethodNode = (function (_MethodNode4) {
  _inherits(InterfaceMethodNode, _MethodNode4);

  function InterfaceMethodNode(name, params, type, isStatic, isOptional) {
    _classCallCheck(this, _InterfaceMethodNode);

    _get(Object.getPrototypeOf(_InterfaceMethodNode.prototype), 'constructor', this).call(this, name, params, type);

    this._static = isStatic;
    this._optional = isOptional;
  }

  _createClass(InterfaceMethodNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var prefix = this._static ? 'static ' : '';

      return '' + prefix + _get(Object.getPrototypeOf(_InterfaceMethodNode.prototype), '_toCode', this).call(this, ctx) + ';';
    }
  }, {
    key: 'name',
    get: function get() {
      return this._optional ? _get(Object.getPrototypeOf(_InterfaceMethodNode.prototype), 'name', this) + '?' : _get(Object.getPrototypeOf(_InterfaceMethodNode.prototype), 'name', this);
    }
  }]);

  var _InterfaceMethodNode = InterfaceMethodNode;
  InterfaceMethodNode = (0, _utils.factory)(InterfaceMethodNode) || InterfaceMethodNode;
  return InterfaceMethodNode;
})(MethodNode);

var InterfacePropertyNode = (function (_Node11) {
  _inherits(InterfacePropertyNode, _Node11);

  function InterfacePropertyNode(name, type, isStatic, isOptional) {
    _classCallCheck(this, _InterfacePropertyNode);

    _get(Object.getPrototypeOf(_InterfacePropertyNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._type = type;
    this._static = isStatic;
    this._optional = isOptional;
  }

  _createClass(InterfacePropertyNode, [{
    key: '_toCode',
    value: function _toCode() {
      var prefix = this._static ? 'static ' : '';
      var name = this._optional ? this._name + '?' : this._name;

      return '' + prefix + name + ': ' + this._type + ';';
    }
  }]);

  var _InterfacePropertyNode = InterfacePropertyNode;
  InterfacePropertyNode = (0, _utils.factory)(InterfacePropertyNode) || InterfacePropertyNode;
  return InterfacePropertyNode;
})(Node);

var InterfaceIndexerNode = (function (_Node12) {
  _inherits(InterfaceIndexerNode, _Node12);

  function InterfaceIndexerNode(name, keyType, returnType) {
    _classCallCheck(this, _InterfaceIndexerNode);

    _get(Object.getPrototypeOf(_InterfaceIndexerNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._keyType = keyType;
    this._returnType = returnType;
  }

  _createClass(InterfaceIndexerNode, [{
    key: '_toCode',
    value: function _toCode() {
      return '[' + this._name + ': ' + this._keyType + ']: ' + this._returnType + ';';
    }
  }]);

  var _InterfaceIndexerNode = InterfaceIndexerNode;
  InterfaceIndexerNode = (0, _utils.factory)(InterfaceIndexerNode) || InterfaceIndexerNode;
  return InterfaceIndexerNode;
})(Node);

var ClassNode = (function (_Node13) {
  _inherits(ClassNode, _Node13);

  function ClassNode(name, superName, members) {
    _classCallCheck(this, _ClassNode);

    _get(Object.getPrototypeOf(_ClassNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._super = superName;
    this._members = members;
  }

  _createClass(ClassNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var members = this._members.map(toCode(_extends({}, ctx, { level: 1 }))).join('\n');
      var superStr = this._super ? ' extends ' + this._super : '';

      return 'class ' + this._name + superStr + ' {\n' + members + '\n}';
    }
  }, {
    key: 'preventSemi',
    get: function get() {
      return true;
    }
  }]);

  var _ClassNode = ClassNode;
  ClassNode = (0, _utils.factory)(ClassNode) || ClassNode;
  return ClassNode;
})(Node);

var ClassMethodNode = (function (_MethodNode5) {
  _inherits(ClassMethodNode, _MethodNode5);

  function ClassMethodNode(name, params, type, isStatic) {
    _classCallCheck(this, _ClassMethodNode);

    _get(Object.getPrototypeOf(_ClassMethodNode.prototype), 'constructor', this).call(this, name, params, type);

    this._static = isStatic;
  }

  _createClass(ClassMethodNode, [{
    key: '_toCode',
    value: function _toCode(ctx) {
      var prefix = this._static ? 'static ' : '';

      return '' + prefix + _get(Object.getPrototypeOf(_ClassMethodNode.prototype), '_toCode', this).call(this, ctx) + ';';
    }
  }]);

  var _ClassMethodNode = ClassMethodNode;
  ClassMethodNode = (0, _utils.factory)(ClassMethodNode) || ClassMethodNode;
  return ClassMethodNode;
})(MethodNode);

var ClassConstructorNode = (function (_ClassMethodNode2) {
  _inherits(ClassConstructorNode, _ClassMethodNode2);

  function ClassConstructorNode(params) {
    _classCallCheck(this, _ClassConstructorNode);

    _get(Object.getPrototypeOf(_ClassConstructorNode.prototype), 'constructor', this).call(this, 'constructor', params, null);
  }

  var _ClassConstructorNode = ClassConstructorNode;
  ClassConstructorNode = (0, _utils.factory)(ClassConstructorNode) || ClassConstructorNode;
  return ClassConstructorNode;
})(ClassMethodNode);

var ClassPropertyNode = (function (_Node14) {
  _inherits(ClassPropertyNode, _Node14);

  function ClassPropertyNode(name, type, isStatic) {
    _classCallCheck(this, _ClassPropertyNode);

    _get(Object.getPrototypeOf(_ClassPropertyNode.prototype), 'constructor', this).call(this);

    this._name = name;
    this._type = type;
    this._static = isStatic;
  }

  _createClass(ClassPropertyNode, [{
    key: '_toCode',
    value: function _toCode() {
      var prefix = this._static ? 'static ' : '';

      return '' + prefix + this._name + ': ' + this._type + ';';
    }
  }]);

  var _ClassPropertyNode = ClassPropertyNode;
  ClassPropertyNode = (0, _utils.factory)(ClassPropertyNode) || ClassPropertyNode;
  return ClassPropertyNode;
})(Node);

function indent(_ref2) {
  var level = _ref2.level;
  var step = _ref2.step;

  if (level === 0) {
    return _utils.id;
  }

  var result = step;
  for (var i = 1; i < indent; i++) {
    result += step;
  }

  return function (source) {
    return result + source;
  };
}

function emptyCtx() {
  return Object.freeze({
    level: 0,
    step: '  ',
    multiVarStep: '  ',
    indent: function indent() {
      return Object.freeze(_extends({}, this, { level: this.level + 1 }));
    }
  });
}

function toCode(ctx) {
  return function (node) {
    return node.toCode(ctx);
  };
}

function createModuleDeclaration(name, nodes) {
  return ModuleDeclarationNode(name, nodes);
}

function createExportAllFrom(source) {
  return ExportAllFromNode(source);
}

function createExportDeclaration(decl) {
  return ExportNamedDeclarationNode(decl);
}

function createVariableDeclaration(kind, decs) {
  return VariableDeclarationNode(kind, decs);
}

function createVariableDeclarator(name, type) {
  return VariableDeclaratorNode(name, type);
}

function createExportSpecifier(exported, local) {
  return ExportSpecifierNode(exported, local);
}

function createExport(specifiers, source) {
  return ExportNode(specifiers, source);
}

function createParam(name, type) {
  var isRest = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  return ParameterNode(name, type, isRest);
}

function createFunction(name, params, type) {
  return FunctionNode(name, params, type);
}

function createInterface(name, members, baseInterfaces) {
  return InterfaceNode(name, members, baseInterfaces);
}

function createInterfaceMethod(name, params, type, isStatic, isOptional) {
  return InterfaceMethodNode(name, params, type, isStatic, isOptional);
}

function createInterfaceProperty(name, type, isStatic, isOptional) {
  return InterfacePropertyNode(name, type, isStatic, isOptional);
}

function createInterfaceIndexer(name, keyType, returnType) {
  return InterfaceIndexerNode(name, keyType, returnType);
}

function createInterfaceCall(params, type) {
  return InterfaceCallNode(params, type);
}

function createClass(name, superName, members) {
  return ClassNode(name, superName, members);
}

function createClassConstructor(params) {
  return ClassConstructorNode(params);
}

function createClassMethod(name, params, type, isStatic) {
  return ClassMethodNode(name, params, type, isStatic);
}

function createClassProperty(name, type, isStatic) {
  return ClassPropertyNode(name, type, isStatic);
}
//# sourceMappingURL=ast.js.map