'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.generate = generate;

var _utils = require('./utils');

var _ast = require('./ast');

var _dts = require('./dts');

function generate(_ref) {
  var moduleId = _ref.moduleId;
  var moduleExports = _ref.moduleExports;
  var moduleImports = _ref.moduleImports;
  var interfaces = _ref.interfaces;
  var root = _ref.root;
  var suppressModulePath = _ref.suppressModulePath;
  var suppressComments = _ref.suppressComments;

  var nodes = moduleImports.concat(interfaces, moduleExports).map((0, _dts.generateNode)({ root: root })).filter(_utils.id);

  var module = (0, _ast.createModuleDeclaration)(suppressModulePath ? root : moduleId, nodes);

  return module.toString({ suppressComments: suppressComments });
}
//# sourceMappingURL=index.js.map